///////////////////////////////////////////////////////////////////////
//                                                   41 Post                                       //
// Unity3D: Programming a machine gun post series                                //
// Created by DimasTheDriver in 06/Feb/2010                                      //
// Part of 'Unity3D: Programming a machine gun - Part 2' post.               //
// Availiable at:     http://www.41post.com/?p=2868                             //
/////////////////////////////////////////////////////////////////////

//A variable that will count how many bullets were shot
private var counter : int = 0;
//a Transform that is used to instantiate the bullet
public var muzzleTransform : Transform;
//a variable to store the Bullet game object loaded from the Resources folder
private var bullet : GameObject;
//A variable that serves as a handle to the newly instantiated bullet
private var instantiatedBullet : GameObject;
//This Quaternion defines the rotation of each instantiated nbllet
private var bulletRotation : Quaternion = new Quaternion(0.7,0,0,0.7);

function Awake()
{
	//load the Bullet prefab from the Resources folder
	bullet = Resources.Load("Bullet");
}

// Update is called once per frame
function Update () 
{
	//while the "Fire1" button is being held down
	if(Input.GetButton("Fire1"))
	{
		//Start the DelayedShot method as a coroutine
		StartCoroutine("DelayedShot",0.2);
	}
}
//A method that returns a IEnumerator so it can be yield
function DelayedShot(delay:float)
{
	//wait for the time defined at the delay parameter
	yield new WaitForSeconds(delay);
	//instantiate the bullet at the gun's muzzle
	instantiatedBullet = Instantiate (bullet, muzzleTransform.position, muzzleTransform.rotation * bulletRotation);
	//add velocity to the bullet
	instantiatedBullet.rigidbody.velocity =  muzzleTransform.TransformDirection(Vector3.forward * 75 );	
	//increase the number of fired bullets
	counter++;
	//Stop this coroutine
	StopCoroutine("DelayedShot");
}

function OnGUI()
{
	//display how many bullets were shot
	GUI.Label(new Rect(10,10,100,30),"Shots fired: "+counter.ToString());
}